require 'mattermost_notification/version'
require 'uri'
require 'net/http'

# a simple helper that post message to Mattermost channel
module MattermostNotification
  mattr_accessor :channel_url

  def self.post(body)
    raise 'body is `nil`' unless body
    raise 'channel_url is `nil`' unless channel_url.present?

    uri = URI channel_url
    request = Net::HTTP::Post.new uri
    request.set_form_data(payload: { text: body }.to_json)

    Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') { |http| http.request request }
  end

  def self.configure(&_block)
    yield self
  end
end
